// Copyright 2021 Code Intelligence GmbH
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package com.example;

import com.code_intelligence.jazzer.api.FuzzedDataProvider;
import java.lang.reflect.InvocationTargetException;

public class ClassLoaderLoadClass {
  public static void fuzzerTestOneInput(FuzzedDataProvider data) throws InterruptedException {
    String input = data.consumeRemainingAsAsciiString();
    try {
      // create an instance to trigger class initialization
      ClassLoaderLoadClass.class.getClassLoader().loadClass(input).newInstance();
      // TODO(khaled): this fails to reproduce the finding. It seems that this is related to not
      // throwing a hard-to-catch error when not running in the fuzzing mode.
      // ClassLoaderLoadClass.class.getClassLoader().loadClass(input).getConstructor().newInstance();
    } catch (ClassNotFoundException | InstantiationException | IllegalAccessException ignored) {
    }
  }
}
